/*
 * $Id: GglMekataHtmlConverterServlet.java,v 1.1.1.1 2002/04/19 14:09:49 kenta Exp $
 *
 * Copyright 2002 Kenta Cho. All rights reserved.
 */
package abagames.gglmekata;

import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;

/**
 * Convert xsl like html to plain html.
 *
 * @version $Revision: 1.1.1.1 $
 */
import javax.servlet.http.HttpServlet;

public class GglMekataHtmlConverterServlet extends HttpServlet {

  public static final String MEKATA_HTML_BASE_FILE_NAME = "ggl_mekata_base.html";

  private String replaceAmp(String str) {
    int idx = str.indexOf('&');
    if ( idx == -1 ) return str;
    if ( str.startsWith("lt;", idx+1) ) {
      return str.substring(0, idx) + "<" + replaceAmp(str.substring(idx+4));
    } else if ( str.startsWith("gt;", idx+1) ) {
      return str.substring(0, idx) + ">" + replaceAmp(str.substring(idx+4));
    } else if ( str.startsWith("amp;", idx+1) ) {
      return str.substring(0, idx) + "&" + replaceAmp(str.substring(idx+5));
    } else if ( str.startsWith("apos;", idx+1) ) {
      return str.substring(0, idx) + "'" + replaceAmp(str.substring(idx+6));
    } else if ( str.startsWith("quot;", idx+1) ) {
      return str.substring(0, idx) + "\"" + replaceAmp(str.substring(idx+6));
    }
    return str;
  }

  private String makeFirstHitString(String firstHit) {
    String URL = XMLHandler.getElement(firstHit, "URL");
    String title = XMLHandler.getElement(firstHit, "title");
    String snippet = XMLHandler.getElement(firstHit, "snippet");
    return "<a href=\"" + URL + "\">" + replaceAmp(title) + "</a><br>"
     + replaceAmp(snippet) + "<br><font color=\"#007700\">" + URL + "</font>";
  }

  public void doGet(HttpServletRequest request,
                    HttpServletResponse response)
   throws ServletException, IOException {
    String data = XMLHandler.readFileString(
     GglMekataServlet.SYSTEM_ROOT_PATH + GglMekataServlet.MEKATA_FILE_NAME);
    String theme = XMLHandler.getElement(data, "theme");
    String fixed = XMLHandler.getElement(data, "fixed");
    String count = XMLHandler.getElement(data, "estimatedTotalResultsCount");

    String firstHit = XMLHandler.getElement(data, "firsthit");
    String firstHitHtml = makeFirstHitString(firstHit);

    String history = XMLHandler.getElement(data, "history");
    StringBuffer historyHtml = new StringBuffer();
    for ( ; ; ) {
      String result = XMLHandler.getElement(history, "result");
      String resultWord = XMLHandler.getElement(result, "word");
      String resultCount = XMLHandler.getElement(result, "estimatedTotalResultsCount");
      String resultFirstHit = XMLHandler.getElement(result, "firsthit");
      if ( result.equals("") ) break;
      historyHtml.append("<tr><td>" + resultWord + " + " + fixed +
       "</td><td align=\"right\">" + resultCount +
       "</td><td align=\"right\">" + (Integer.parseInt(resultCount) - Integer.parseInt(count)) +
       "</td><td>" + makeFirstHitString(resultFirstHit) + "</td></tr>");
      history = XMLHandler.removeElement(history, "result");
    }

    String baseHtml = XMLHandler.readFileString(
     GglMekataServlet.SYSTEM_ROOT_PATH + MEKATA_HTML_BASE_FILE_NAME);
    baseHtml = XMLHandler.replaceElement(baseHtml, "xsl:value-of select=\"theme\"", theme);
    baseHtml = XMLHandler.replaceElement(baseHtml, "xsl:value-of select=\"fixed\"", fixed);
    baseHtml = XMLHandler.replaceElement(baseHtml, "xsl:apply-templates select=\"count\"", count);
    baseHtml = XMLHandler.replaceElement(baseHtml, "xsl:apply-templates select=\"firsthit\"", firstHitHtml);
    baseHtml = XMLHandler.replaceElement(baseHtml, "xsl:apply-templates select=\"history/result\"", historyHtml.toString());

    response.setContentType("text/html; charset=UTF-8");
    PrintWriter out = new PrintWriter(new OutputStreamWriter(response.getOutputStream(), "UTF-8"));
    out.print(baseHtml);
    out.close();
  }
}
