/*
 * $Id: GglMekataSetThemeServlet.java,v 1.1.1.1 2002/04/19 14:09:50 kenta Exp $
 *
 * Copyright 2002 Kenta Cho. All rights reserved.
 */
package abagames.gglmekata;

import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;

/**
 * Servlet to set a theme word of GoogryuMekataDeDon.
 *
 * @version $Revision: 1.1.1.1 $
 */
public class GglMekataSetThemeServlet extends HttpServlet {

  public void doGet(HttpServletRequest request,
                    HttpServletResponse response)
   throws ServletException, IOException {
    response.setContentType("text/plain");
    PrintWriter out = response.getWriter();
    out.println("GglMekataSetThemeServlet ready.");
    out.close();
  }

  private String getStringFromForm(String text)
    throws UnsupportedEncodingException {
    return new String(text.getBytes("8859_1"), "UTF-8");
  }

  private static final String MEKATA_LOG_FILE_NAME = "ggl_mekata_log.cocoon.xml";

  public void doPost(HttpServletRequest request,
                     HttpServletResponse response)
   throws ServletException, IOException {
    String theme = getStringFromForm(request.getParameter("theme"));
    String fixed = getStringFromForm(request.getParameter("fixed"));
    String key = getStringFromForm(request.getParameter("key"));

    if ( !key.equals(AccessGoogle.getKey()) ) {
      response.setContentType("text/plain");
      PrintWriter out = response.getWriter();
      out.println("Invalid google key.");
      out.close();
      return;
    }

    try {
      String oldlog = XMLHandler.readFileString(
       GglMekataServlet.SYSTEM_ROOT_PATH + GglMekataServlet.MEKATA_FILE_NAME);
      XMLHandler.writeFileString(
       GglMekataServlet.SYSTEM_ROOT_PATH + MEKATA_LOG_FILE_NAME, oldlog);
    } catch ( Exception e ) {}

    String carStr = "<?xml version='1.0' encoding='UTF-8'?><?xml-stylesheet href=\"ggl_mekata.xsl\" type=\"text/xsl\"?><?cocoon-process type=\"xslt\"?><gglmekata xmlns:xsi=\"http://www.w3.org/1999/XMLSchema-instance\">";
    carStr += "<theme>" + theme + "</theme>";
    carStr += "<fixed>" + fixed + "</fixed>";
    String result = new AccessGoogle().search(theme + " " + fixed);
    carStr += "<firsthit>"
     + XMLHandler.getElementWithTag(result, "URL")
     + XMLHandler.getElementWithTag(result, "title")
     + XMLHandler.getElementWithTag(result, "snippet")
     + "</firsthit>";
    carStr += "<count>"
     + XMLHandler.getElementWithTag(result, "estimatedTotalResultsCount")
     + "</count>";
    carStr += "<history>";
    XMLHandler.writeFileString(
     GglMekataServlet.SYSTEM_ROOT_PATH + GglMekataServlet.MEKATA_CAR_FILE_NAME, carStr);

    String cdrStr = "</history></gglmekata>";
    XMLHandler.writeFileString(
     GglMekataServlet.SYSTEM_ROOT_PATH + GglMekataServlet.MEKATA_CDR_FILE_NAME, cdrStr);

    XMLHandler.writeFileString(
     GglMekataServlet.SYSTEM_ROOT_PATH + GglMekataServlet.MEKATA_FILE_NAME, carStr + cdrStr);

    //response.sendRedirect(
    // GglMekataServlet.SYSTEM_ROOT_URI + GglMekataServlet.MEKATA_FILE_NAME);
    response.sendRedirect(
     GglMekataServlet.SYSTEM_URI + GglMekataServlet.MEKATA_CONVERT_SERVLET_NAME);
  }
}
